<template>
    <div class="wrapper">
        <div class="container-fuild">
            <div id="headTitle">
                <Logo />
                <h1 id="title" _msttexthash="48503" _msthash="2">{{ i18ntext.lngText('POS') }}</h1>
            </div>
        </div>
        <div class="container-fuild">
            <Header />
            <ol id="topicPath">
                <li style="margin-left: 227px">
                    <router-link to="">
                        <a href="dashbaord">
                            <font style="vertical-align: inherit"></font>
                            <font style="vertical-align: inherit"> {{ i18ntext.lngText('POS') }} </font>
                        </a>
                    </router-link>
                </li>
            </ol>
        </div>
        <div class="search-box-title">
            <router-link to="/pos">
                <a class="btn-radius btn btn-sm" href="#" style="
            color: #f8f5b4;
            margin-top: -2px;
            font-size: 18px;  
            color: #dbdee1;
            background-color: #29a5a5;
            border: #22adb763 1px solid;
          ">
                    <i class="fa fa-cog" aria-hidden="true"></i>
                    {{ i18ntext.lngText('POS') }}
                </a>
            </router-link>

         
              <a
                class="btn-radius bt-pn btn btn-sm"
                data-bs-toggle="dropdown"
                aria-expanded="false"
                style="float: right; color: #f8f5b4; margin-top: -2px; width:79px"
              >

                <i class="fa fa-bars" aria-hidden="true"></i>
                {{ i18ntext.lngText('menu') }}
              </a>
              <ul class="dropdown-menu">
                <li>
                  <a

                    class="dropdown-item btn btn-primary"
                    data-bs-toggle="modal"
                    data-bs-target="#staticboomId"
                    tabindex="10028"
                    >
                    <button class="btn-patient" id="option_menu" type="button" data-bs-toggle="modal"
                                data-bs-target="#patientInfo"> <span >{{ i18ntext.lngText('patientroom') }}</span> </button>
                    </a
                  >
                </li>
                <li>
                  <a
                    @click="importSheet()"
                    class="dropdown-item"
                    data-bs-toggle="modal"
                    data-bs-target="#excelCategory"
                    tabindex="10028"
                    href="#"
                    ><i class="fas fa-file-excel"></i>
                      {{ i18ntext.lngText('import') }}
                    </a
                  >
                </li>
                <li>
                  <a
                    @click="exportSheet()"
                    class="dropdown-item btn btn-primary"
                    data-bs-toggle="modal"
                    data-bs-target="#excelCategory"
                    tabindex="10028"
                    ><i class="fas fa-file-excel"></i>
                      {{ i18ntext.lngText('export') }}
                  </a>
                </li>
                <li>
                  <a
                  @click="BackToHistory()"
                    class="dropdown-item btn btn-primary"
                    tabindex="10028"
                  >
                    <i class="fa fa-print" aria-hidden="true"></i>
                      {{ i18ntext.lngText('toproduct') }}
                </a>
                </li>
              </ul>
            <!-- </div> -->
        </div>

        <!-- OPTION CUSTOMER -->

        <div class="modal fade ui-modal" id="savereverse" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
            aria-labelledby="closeconfirm" aria-hidden="true">
            <div class="modal-dialog smallpopup" id="nonbackgroundboom">
                <div class="modal-content ui-dialog" style="width: 200%; margin-left: -50%;">
                    <div class="ui-widget-header">
                        <h5 class="modal-title" id="exampleModalLabel">
                            <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">{{
                                i18ntext.lngText('confirm_message')
                            }}</span>
                        </h5>
                        <span class="ui-icon ui-icon-closethick btn-cancel" data-bs-dismiss="modal"
                            aria-label="Close"></span>
                    </div>
                    <div class="ui-dialog-content" style="background-color: #fff">
                        <div v-if="save_reverse === 'Reverse'" class="modal-body">{{ i18ntext.lngText('reverse_ask') }}
                        </div>
                        <div v-else class="modal-body">
                        </div>

                        <div class="modal-footer">
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- OPTION CUSTOMER -->

        <div class="pos-container ">
            <div class="pos-content ">
                <div class="left-path edittwo">
                    <div class="search-part edit_search">
                        <div class="d-flex" id="input" style="width: 100%; margin-top: 20px;">
                            <label for="">CHECK-IN DATE  <i class="fa fa-arrow-right" aria-hidden="true" style="margin-left: 10px;"></i></label>
                            <input type="date" class="inputone">
                            <label for="">CHECK-OUT   <i class="fa fa-arrow-right" aria-hidden="true" style="margin-left: 10px;"></i></label>
                            <input type="date" class="inputtwo">
                            <button class="btn-patient" type="button" data-bs-toggle="modal" data-bs-target="">{{
                                i18ntext.lngText('search') }}</button>
                        </div>
                    </div>
                    <div class="product-part" id="part-edit" style="margin-left: 1%;  width: 100% ;">
                        <ul>
                            <li class="list_cat" @click="showmodal()">
                                <div class="col-12 list_cat-1">
                                    <div class="list_cat-2">

                                    </div>
                                    <div class="list_text">
                                        <p class="pro-name text-center" style="font-size: 20px; font-weight: 700;">Room A01
                                        </p>
                                    </div>
                                </div>
                            </li>
                            <li class="list_cat">
                                <div class="col-12 list_cat-1">
                                    <div class="list_cat-2"><img src="room/home(2).png" alt=""></div>
                                    <div class="list_text">
                                        <p class="pro-name text-center" style="font-size: 20px; font-weight: 700;">Room A02
                                        </p>
                                    </div>
                                </div>
                            </li>
                            <li class="list_cat">
                                <div class="col-12 list_cat-1">
                                    <div class="list_cat-2"><img src="room/home(1).png" alt=""></div>
                                    <div class="list_text">
                                        <p class="pro-name text-center" style="font-size: 20px; font-weight: 700;">Room A03
                                        </p>
                                    </div>
                                </div>
                            </li>
                            <li class="list_cat">
                                <div class="col-12 list_cat-1">
                                    <div class="list_cat-2"><img src="room/home(2).png" alt=""></div>
                                    <div class="list_text">
                                        <p class="pro-name text-center" style="font-size: 20px; font-weight: 700;">Room A04
                                        </p>
                                    </div>
                                </div>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
        <!-- HOME -->

        <!-- HOME -->
    </div>
    <div class="modal fade ui-modal" id="bookingroom" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
        aria-labelledby="staticBackdropss" aria-hidden="true">
        <div class="modal-dialog" id="show">
            <div class="modal-content ui-dialog">
                <div class="modal-header">
                    <h5 class="modal-title" id="bookingdate">
                        <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">
                            {{ i18ntext.lngText('bookingnow') }}</span>
                    </h5>
                    <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
                </div>
                <div style="background-color: #6db7bf; overflow: hidden; width: 100%;">
                    <div class="row" style="width: 113.5%;">
                        <div class="col-xl-2 checkin">
                            <div class="label" style="width: 100%;  height: 60px;">
                                <label for="" style="font-size: 18px; margin-top:10px; margin-left: 3%;">
                                    {{ i18ntext.lngText('check-in date') }}</label>
                            </div>
                            <input type="date" style="width: 100%; height: 43px; font-size: 20px; border-radius: 5px;">
                        </div>
                        <div class="col-xl-2 checkout">
                            <div class="label" style="width: 100%;  height: 60px;">
                                <label for="" style="font-size: 18px; margin-top:10px; margin-left: 3%;">
                                    {{ i18ntext.lngText('check-out date') }}</label>
                            </div>
                            <input type="date" style="width: 100%; height: 43px; font-size: 20px; border-radius: 5px;">
                        </div>
                        <div class="col-xl-2 room">
                            <div class="label" style="width: 100%;  height: 60px;">
                                <label for="" style="font-size: 18px; margin-top:10px; margin-left: 32%;">
                                    {{ i18ntext.lngText('roomr') }}</label>
                            </div>
                                <input type="text" style="width: 100%; height: 43px; font-size: 23px; border-radius: 5px;">
                            <!-- <select name="" id="" style="width: 100%; height: 43px; font-size: 23px; border-radius: 5px;">
                                <option value="1room">{{ i18ntext.lngText('1room') }}</option>
                                <option value="2room">{{ i18ntext.lngText('2room') }}</option>
                                <option value="3room">{{ i18ntext.lngText('3room') }}</option>
                            </select> -->
                        </div>
                        <div class="col-xl-2 children">
                            <div class="label" style="width: 100%; height: 60px;">
                                <label for="" style="font-size: 18px; margin-top: 10px; margin-left: 35%;">
                                    {{ i18ntext.lngText('nightr') }}</label>
                            </div>
                            <input type="text" style="width: 100%; height: 43px; font-size: 23px; border-radius: 5px;">
                            <!-- <select name="" id="" style="width: 100%; height: 43px; font-size: 23px; border-radius: 5px;">
                                <option value="1night">{{ i18ntext.lngText('1night') }}</option>
                                <option value="2night">{{ i18ntext.lngText('2night') }}</option>
                                <option value="3night">{{ i18ntext.lngText('3night') }}</option>
                            </select> -->
                        </div>
                        <div class="col-xl-2 adults">
                            <div class="label" style="width: 100%;  height: 60px;">
                                <label for="" style="font-size: 18px; margin-top:10px; margin-left: 22%;">
                                    {{ i18ntext.lngText('adults') }}</label>
                            </div>
                                <input type="text" style="width: 100%; height: 43px; font-size: 23px; border-radius: 5px;">
                            <!-- <select name="" id="" style="width: 100%; height: 43px; font-size: 23px; border-radius: 5px;">
                                <option value="1adults">{{ i18ntext.lngText('1adults') }}</option>
                                <option value="2adults">{{ i18ntext.lngText('2adults') }}</option>
                                <option value="3adults">{{ i18ntext.lngText('3adults') }}</option>
                            </select> -->
                        </div>

                    </div>
                </div>
                <div class="jaol" style="width: 100%; height: 30px;  background-color: #6db7bf;"></div>
                <div class="modal-footer" style="height: 70px;">
                    <button type="button" class="btn btn-info"
                        style="   margin-left:0%;width: 30%; height: 46px; font-size: 25px;  margin-top: -2.2px; box-shadow:rgba(5, 15, 15, 15);">
                        {{ i18ntext.lngText('bookingf') }}</button>
                    <div class="button type2" id="uniform-undefined">
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade ui-modal" id="patientInfo" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
        aria-labelledby="closeconfirm" aria-hidden="true">
        <div class="modal-dialog" style="    max-width: 130vh !important;" id="patientInfo">
            <div class="modal-content ui-dialog">
                <div class="ui-widget-header">
                    <h5 class="modal-title" id="exampleModalLabel">
                        <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">{{ i18ntext.lngText('customer')
                        }}</span>
                    </h5>
                    <span class="ui-icon ui-icon-closethick btn-cancel" data-bs-dismiss="modal" aria-label="Close"></span>
                </div>
                <div class="ui-dialog-content" style="background-color: #fff">
                    <table width="100%" border="0" cellpadding="0" cellspacing="0" class="tbl_search" id="hover-table">
                        <tbody>
                            <tr>
                                <th width="15%">{{ i18ntext.lngText('patientid') }}</th>
                                <td width="90%">
                                    <input class="string_zen_kana clear_text text" style="width: 36%;" size="50" type="text"
                                        v-model="patient.pateinid" tabindex="10000">
                                </td>
                            </tr>
                            <tr>
                                <th width="15%"> {{ i18ntext.lngText('firstname') }}</th>
                                <td width="90%" colspan="3">
                                    <div class="grid">
                                        <div class="gd">
                                            <input class="string_zen_kana clear_text text" v-model="patient.firstname"
                                                size="20" type="text" @keyup.enter="createAlert()">
                                            <!-- <p class="error-alert1">{{i18ntext.lngText('field_require')}}</p> -->
                                        </div>
                                        {{ i18ntext.lngText('lastname') }} <span style="color:red">*</span>
                                        <div class="gd">
                                            <input class="string_zen_kana clear_text text" v-model="patient.lstname"
                                                size="20" type="text" @keyup.enter="createAlert()">
                                            <!-- <p  class="error-alert1">{{i18ntext.lngText('field_require')}}</p> -->
                                        </div>

                                        {{ i18ntext.lngText('sex') }}
                                        <div class="gd">
                                            <select v-model="patient.sex">
                                                <option>Male</option>
                                                <option>Female</option>
                                            </select>
                                        </div>
                                        {{ i18ntext.lngText('age') }}
                                        <input :disabled="is_close" class="string_zen_kana clear_text text" size="10"
                                            type="number" style="width:4em" v-model="patient.age"
                                            @change="getage(patient.age)">
                                        {{ i18ntext.lngText('birth') }}
                                        <input :disabled="is_close" class="string_zen_kana clear_text text" name="QtyCode"
                                            size="50" type="date" v-model="patient.birstdate">
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <th width="15%">{{ i18ntext.lngText('phonenumber') }}</th>
                                <td width="90%">
                                    <input :disabled="is_close" class="string_zen_kana clear_text text" size="20"
                                        type="text" v-model="patient.phone1">
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <div class="search-box-footer">
                        <div class="button type2" id="uniform-undefined"><span><i class="fa fa-trash"
                                    aria-hidden="true"></i> {{ i18ntext.lngText('clear') }}<input type="button"
                                    class="type2" style="opacity: 0; width: 54px;"></span></div>
                        <div class="button type2" id="uniform-undefined" @click="searchPatient()"><span><i
                                    class="fa fa-search"></i> {{ i18ntext.lngText('search') }}</span></div><span
                            class="marker"></span>
                    </div>
                    <div class="box mt-4">
                        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="table table-striped br-table"
                            style="border-top: 1px solid #6eb3bf">
                            <thead>
                                <tr class="header-table">
                                    <th style="width: 5%">{{ i18ntext.lngText('no') }}</th>
                                    <th style="width: 10%">{{ i18ntext.lngText('patientid') }}</th>
                                    <th style="min-width: 40%">{{ i18ntext.lngText('lastname') }}</th>
                                    <th style="width: 12%">{{ i18ntext.lngText('phonenumber') }}</th>
                                    <th style="width: 12%">{{ i18ntext.lngText('birth') }}</th>
                                    <th style="width: 11%">{{ i18ntext.lngText('age') }}</th>
                                    <th style="width: 10%">{{ i18ntext.lngText('address') }}</th>
                                    <th style="width: 10%"></th>
                                </tr>
                            </thead>
                            <tbody>

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>


    <Footer />
    <UserInfo />
</template>
<script>
import { thisExpression } from "@babel/types";
import moment from "moment";
import Auth from "../../auth/Auth";
import Header from "../Header.vue";
import axios from "axios";
import Footer from "../footer.vue";
import i18n from "../../i18n/i18n";
import UserInfo from "../UserInfo.vue";
import Logo from "../logo.vue";
import { log } from "mathjs";
import { MultiSelect } from "vue-search-select";
export default {
    components: { Header, Logo, Footer, UserInfo, MultiSelect },
    data() {
        return {
            i18ntext: i18n,
            save_reverse: 'Save',
            formOpen: {
                id: "",
                description: "",
                deposit: "",
                deposit2: "",
                curency: "",
                statue: "",
                created_by: Auth.user.id,
                updated_by: '',
            },
            Employee_Name: Auth.user.user_name,
            clickTick: [],
            exchanges: [],
            seller: Auth.user.user_name,
            productName: "",
            shitfs: [],
            category: [],
            form_lines: [],
            testw: [],
            items: 0,
            message: '',
            products: [],
            selectProduct: [],
            company: {},
            bassUrl: "",
            check: true,
            checkItems: [],
            units: [],
            cur: "KHR",
            paymentmethodselect: "Cash",

            form: {
                document_no: "",
                document_type: "",
                description: "",
                suppliyer_code: "",
                exchangerate: 0,
                curency_code: "USA",
                inactived: "",
                status: "",
            },
            pospayment: {
                amount: 0,
                amount2: 0,
                amount_kh: 0,
                totalpay: 0,
                discount: 0,
                changeUS: 0,
                changeKH: 0,
                payOne: '',
                payTwo: '',
                amountUSD: 0,
                exchange_rate: 0,
                paymeny_method: 'Cash',
                age: '',
                weight: '',
                group_code: '',

            },
            search: "",
            expression: "",
            prodcutstore: [],
            getSe: [],
            sales: [],
            salelinks: [],
            dateformart: '',
            getcloseshifts: [],
            getamount: 0,
            total_amountusd: 0,
            invoinces: '',

            pos_sale_item: [],
            sum_pos: 0,
            prescription_sale_item: [],
            sum_pre: 0,
            labo_sale_item: [],
            sum_labo: 0,

            sum_total: 0,
            sum_total_usd: 0,

            diagnosis: '',
            options: [],
            data: [],

            formSearch: {
                cate_list: []
            },
            patient: {
                id: "",
                sex: "",
                preid: "",
                pateinid: "",
                lstname: "",
                firstname: "",
                group_code: "",
                phone1: "",
                phone2: "",
                birstdate: "",
                remark: "",
                age: "",
                type: "prescription",
                village: "",
                commune: "",
                district: "",
                pro_city: "",
                width: "",
                height: "",
                created_by: "",
                updated_by: "",
                status: "",
                patient: {},
            },
        };
    },
    watch: {
        clickTick(newVal) {
            if (newVal) {
                this.getSe = [];
                this.prodcutstore.forEach((e) => {
                    newVal.forEach((x) => {
                        if (e.cat_code == x) {
                            this.getSe.push(e);
                        }
                    });
                });
                this.products = this.getSe;
            } else {
                alert("wrong");
            }
        },

    },

    mounted() {
        if (Auth.check()) {
            if (!Auth.checkPermission("PHARMACY_ALL")) {
                this.$router.push("/dashboard");
            }
        }
        this.bassUrl = axios.defaults.baseURL;
        this.getCatName();
        this.getdatagroup()
        this.getproduct();
        this.getdataPos();
        this.getUnit();
        this.getEmployee();
        this.getExchange();
        this.getcompany();
        this.isHaveReverseItem()
    },
    // computed: {},
    methods: {
        showmodal() {
            $('#bookingroom').modal('show');
        },

        async searchPatient() {
            this.is_close = false;
            this.form.created_by = Auth.user.id;
            await axios.post("api/v1/patient/searchEnterPatient", this.patient).then((res) => {
                if (res.data.status == 1) {
                    this.patient = res.data.data;
                    console.log(this.patient);
                }
                if (res.data.status == 0) {
                    alert(res.data)
                }
            });
        },
        getage(age) {
            if (age >= 0) {
                var base = new Date();
                var mydate = base.setFullYear(base.getFullYear() - parseInt(age));
                this.patient.birstdate = new Date(mydate).toISOString().slice(0, 10);
                this.updateRegister();
            }
        },
        clickMulti() {
            console.log('you click my ti')
            let hello = document.querySelector(".selection")
            hello.classList.add('ddd')
            console.log(hello)
        },

        async getPatient(id) {
            await axios.get('api/v1/payment/getReversePatient/' + id)
                .then(res => {
                    this.pospayment.age = res.data.data.age
                    this.pospayment.group_code = res.data.data.group_code
                    this.pospayment.weight = res.data.data.width

                    this.test(this.pospayment.group_code)
                })
        },

        //search medicine by diagnosis
        async searchDiagnosis() {
            if (this.diagnosis != '') {
                await axios.get('api/v1/products/searchMedicineByDiagnosis/' + this.diagnosis)
                    .then(res => {
                        this.products = res.data.data
                    })
            } else {
                this.getproduct()
            }

        },
        async getdatagroup() {
            await axios.get("/api/v1/progroups/getdatagroup").then((response) => {
                response.data.forEach((element) => {
                    this.options.push({
                        value: element.group_name,
                        text: element.group_name,
                    });
                });
            });
        },

        onSelect(x) {
            if (x != '') {
                this.data = x;
                if (this.data.length > 0) {
                    this.diagnosis = "";
                    x.forEach((e) => {
                        if (e.value != null) {
                            if (this.diagnosis == "") {
                                this.diagnosis = e.value;
                                this.pospayment.group_code = this.diagnosis
                            }
                            else {
                                this.diagnosis = this.diagnosis + "," + e.value;
                                this.pospayment.group_code = this.diagnosis
                            }
                        }
                    });
                    this.searchDiagnosis()
                }
            }
            else {
                this.data = []
                this.getproduct()
            }
        },
        async test(z) {

            console.log(z);
            try {
                var y = z.split(",");
                this.data = [];
                for (var i = 0; i <= y.length; i++) {
                    if (y[i].trim() != "undefined" && y[i] != "") {
                        this.data.push({
                            value: y[i],
                            text: y[i],
                        });
                    }
                }
            } catch (error) { }
        },

        //end
        payOne() {
            if (this.pospayment.payOne == "" || this.pospayment.payOne == null) {
                this.pospayment.payTwo = '';
                this.pospayment.changeUS = "";
                this.pospayment.changeKH = "";
            }
            this.exchanges.forEach((e) => {
                const pay = this.pospayment.totalpay / e.exchange_rate;
                if (this.pospayment.payOne >= pay) {
                    this.pospayment.payTwo = 0;
                    this.pospayment.changeUS = this.pospayment.payOne - pay;
                    this.pospayment.changeKH = this.pospayment.changeUS * e.exchange_rate;
                    if (this.pospayment.changeKH < 100) {
                        this.pospayment.changeKH = 0;
                        this.pospayment.changeUS = 0;
                    }
                } else if (this.pospayment.payOne < pay) {
                    this.pospayment.payTwo = pay - this.pospayment.payOne;
                    this.pospayment.payTwo = parseFloat((this.pospayment.payTwo * e.exchange_rate).toFixed(0));
                    if (this.pospayment.payTwo < 100) { this.pospayment.payTwo = 0 }
                    this.pospayment.changeUS = "";
                    this.pospayment.changeKH = "";
                }
            });
        },
        paytwo() {
            if (this.pospayment.payTwo == "" || this.pospayment.payTwo == null) {
                this.pospayment.payTwo = "";
                this.pospayment.changeUS = "";
                this.pospayment.changeKH = "";
            }
            this.exchanges.forEach((e) => {
                const pay = this.pospayment.totalpay;
                if (this.pospayment.payTwo >= pay) {
                    this.pospayment.changeKH = this.pospayment.payTwo - pay;
                    if (this.pospayment.changeKH < 100) this.pospayment.changeKH = 0;
                    this.pospayment.changeUS = this.pospayment.payTwo / e.exchange_rate;
                    this.pospayment.payOne = 0;
                    this.pospayment.changeUS = (this.pospayment.payTwo - pay) / e.exchange_rate;
                } else if (this.pospayment.payTwo < pay) {
                    this.pospayment.changeUS = "";
                    this.pospayment.changeKH = "";
                    this.pospayment.payOne = parseFloat(((pay - this.pospayment.payTwo) / e.exchange_rate).toFixed(3));
                }
            });
        },
        getcompany() {
            axios.get("/api/v1/getSetup")
                .then((response) => {
                    this.company = response.data;
                });
        },
        unCheck() {
            if (this.clickTick.length <= 0) {
                this.products = this.prodcutstore;
            }
        },
        discountBtn() {
            if (this.pospayment.discount <= 100) {
                var x;
                x = (this.pospayment.discount / 100) * this.pospayment.amount;
                this.pospayment.totalpay = this.pospayment.amount - x;
            } else {
                this.pospayment.discount = 0;
            }
        },
        calculate() {
            this.pospayment.discount = evaluate(this.pospayment.discount);
        },
        getExchange() {
            axios.get("/api/v1/exchangerate/find/USD").then((data) => {
                this.exchanges = data.data.lists;

                this.pospayment.exchange_rate = this.exchanges[0].exchange_rate;
            });
        },
        mysearch(page = 1) {
            axios
                .get("/api/v1/products/diagnos?page=" + page + "/", { params: { search: this.search } })
                .then((res) => {
                    this.products = res.data.data;
                })
                .catch((error) => { });
        },
        formatPrice(value, cur) {
            if (cur == "KHR") cur = "r";
            try {
                var formatter = new Intl.NumberFormat("en-US", {
                    style: "currency",
                    currency: cur,
                    minimumFractionDigits: 2,
                });
                return formatter.format(value);
            } catch (error) {
                var formatter = new Intl.NumberFormat("en-US", {
                    minimumFractionDigits: 2,
                });
                return formatter.format(value);
            }
        },
        getclick(value) {
            this.paymentmethodselect = value;
            this.pospayment.paymeny_method = this.paymentmethodselect;
            if (value == 'Cash') {
                this.pospayment.payOne = 0;
                this.pospayment.payTwo = 0;
            } else {
                this.pospayment.changeUS = 0;
                this.pospayment.changeKH = 0;
                this.pospayment.payOne = this.pospayment.totalpay / this.pospayment.exchange_rate;
                this.pospayment.payTwo = this.pospayment.totalpay;
            }
        },
        getUnit() {
            axios.get("/api/v1/paymentvoucher/getPaymenmethod/").then((response) => {
                this.units = response.data;
            });
        },
        getCatName() {
            axios.get("/api/v1/category/getCatName").then((response) => {
                this.category = response.data;
            });
        },
        Clearall() {
            this.form.created_by = Auth.user.id;
            axios.post("/api/v1/pos/clear", this.form).then(() => {
                this.getdataPos();
            });
            this.pospayment.totalpay = 0;
        },

        getproduct() {
            axios.get("/api/v1/products/productSell").then((response) => {
                this.products = response.data.data;
                this.prodcutstore = this.products;
            });
        },
        getselectProduct(product, pro) {
            $('#patientInfo').modal('show');
            if (parseInt(pro.inventory) == 0) {
                this.invoinces = pro.inventory;
                $('#itemnoteqaul').modal('show');
            }
            else {
                $('#staticBackdropss').modal('show')
                axios.get("/api/v1/products/units/" + product).then((response) => {
                    this.form_lines = response.data;
                    this.form_lines.forEach((element) => {
                        element.inventory = 1;
                    });
                });
            }
        },
        getdataPos() {
            this.form.created_by = Auth.user.id;
            axios
                .get("/api/v1/pos/getposdata?created_by=" + this.form.created_by)
                .then((response) => {
                    this.selectProduct = response.data;
                    if (this.selectProduct[0].document_no != '' && this.selectProduct[0].document_no != null) {
                        this.getPatient(this.selectProduct[0].document_no)
                    }
                    this.sum(this.selectProduct);
                });
        },
        getproductName(pro) {
            this.productName = pro.description;
        },
        possave(datapos) {
            datapos.created_by = Auth.user.id;
            datapos.total_amount = parseFloat(datapos.inventory) * parseFloat(datapos.unit_price);
            axios.post("/api/v1/pos/inpossale", datapos).then((data) => {
                if (data.data.statue) {
                    this.getdataPos();
                } else {
                    this.getdataPos();
                    this.invoinces = data.data.inventory;
                    $('#itemnoteqaul').modal('show');

                }
            });
        },
        searchProduct(product) {
            if (this.selectProduct.length > 0) {
                this.check = false;
                this.selectProduct.forEach((element) => {
                    if (
                        element.product_no == product.product_no &&
                        element.unit_code == product.variant_unit_of_measure_code
                    ) {
                        this.check = true;
                        this.checkItems = element;
                    }
                });
                this.submitt(this.check, product, this.checkItems);
            } else if ((product.product_no != "") & (this.selectProduct == "")) {
                this.possave(product);
            } else {
                this.possave(product);
            }
            this.sum(this.selectProduct);
        },
        submitt(check, getPro, SetPro) {
            if (check) {
                SetPro.inventory = parseFloat(SetPro.inventory) + parseFloat(getPro.inventory);
                SetPro.amount =
                    parseFloat(SetPro.inventory) * parseFloat(getPro.unit_price);
                this.update(SetPro);
            } else {
                getPro.amount = getPro.unit_price;
                this.possave(getPro);
            }
        },
        sum(pro) {
            this.pospayment.amount = 0;
            this.pospayment.amount_kh = 0;
            this.items = 0;
            pro.forEach((element) => {
                this.pospayment.amount = this.pospayment.amount + parseFloat(element.total_amount);
                this.pospayment.amount_kh = this.pospayment.amount_kh + parseFloat(element.total_amount);
                this.pospayment.totalpay = this.pospayment.amount;
                this.items = this.items + 1;
            });
        },
        minus(item) {
            try {
                var vl = parseFloat(item.inventory);
                if (vl > 1) {
                    item.inventory = vl - 1;
                    item.amount = parseFloat(item.inventory) * parseFloat(item.unit_price);
                    item.total_amount = item.amount;
                    this.update(item);
                } else {
                    this.deleteDate(item.id);
                }
            } catch (error) { }
        },
        plus(item) {
            var vl = parseFloat(item.inventory);
            item.inventory = vl + 1;
            item.amount = parseFloat(item.inventory) * parseFloat(item.unit_price);
            item.total_amount = item.amount;
            this.update(item);
        },
        update(item) {
            axios.post("/api/v1/pos/update/" + item.id, item).then((res) => {
                if (res.data.statue) {
                } else {
                    this.invoinces = res.data.inventory;
                    $('#itemnoteqaul').modal('show');
                }
                this.getdataPos();
            });
        },
        deleteDate(item) {
            this.form.created_by = Auth.user.id;
            axios.post("/api/v1/pos/delete/" + item, this.form).then(() => {
                this.getdataPos();
            });
        },
        getEmployee() {
            Auth.user.created_by = Auth.user.id;
            axios.post("/api/v1/closeshift/getcheck", Auth.user).then((res) => {
                if (res.data == '') {
                } else {
                    this.formOpen = res.data;
                }
            });
        },
        paynow() {
            this.pospayment.created_by = Auth.user.id;
            this.pospayment.type = 'pos';
            this.dateformart = moment(new Date()).format('YYYY-MM-DD h:m:s');
            if (!this.pospayment.payOne && !this.pospayment.payTwo && this.pospayment.paymeny_method == "Cash" || this.pospayment.payOne == 0 && this.pospayment.payTwo == 0 && this.pospayment.paymeny_method == "Cash") {

            } else {

                axios.post("/api/v1/payment/paymepos", this.pospayment).then((res) => {
                    if (res.data.statue) {
                        this.sales = res.data.Sale;
                        this.salelinks = res.data.Saleline;
                        $('#pay1').modal('show');
                        this.pospayment.totalpay = 0;
                        this.pospayment.amount = 0
                        this.pospayment.payOne = '';
                        this.pospayment.payTwo = '';
                        this.pospayment.changeUS = '';
                        this.pospayment.changeKH = '';
                        this.pospayment.discount = 0;
                        this.data = []
                        this.pospayment.group_code = ''
                        this.pospayment.age = ''
                        this.pospayment.weight = ''
                        this.getproduct()
                    }
                });
            }
        },
        closeshift() {
            this.formOpen.updated_by = Auth.user.id;
            axios
                .post("/api/v1/closeshift/update/" + this.formOpen.id, this.formOpen)
                .then((res) => {
                    this.formOpen = res.data;
                    $('#closeshift_invoecne').modal('show');
                    this.getEmployee();
                });
        },
        getcloseshift() {
            this.formOpen.updated_by = Auth.user.id;
            axios
                .get("/api/v1/pos/getposcloseshift/" + Auth.user.id)
                .then((res) => {

                    this.pos_sale_item = res.data.pos[0].element
                    this.sum_pos = res.data.pos[0].total

                    this.prescription_sale_item = res.data.pre[0].element
                    this.sum_pre = res.data.pre[0].total


                    this.labo_sale_item = res.data.labo[0].element
                    this.sum_labo = res.data.labo[0].total
                    this.sum_total = res.data.total
                    this.sum_total_usd = res.data.total_usd

                });
        },
        openshift() {
            this.formOpen.created_by = Auth.user.id;
            axios.post("/api/v1/closeshift/create", this.formOpen).then((res) => {
                if (res.data.statue) {
                    this.getEmployee();
                } else {
                    alert("wrong");
                }
            });
        },
        none() {
            this.pospayment.discount = "";
        },
        messagebox() {
            var modal = document.getElementById("myModal");
            modal.style.display = "block";
            setTimeout(() => (modal.style.display = "none"), 1500);
        },
        summitpos() {
            this.formOpen.created_by = Auth.user.id;
            axios.post("/api/v1/payment/paymepos", this.formOpen).then((res) => {
                if (res.data.statue) {
                    this.formOpen = res.data.data;
                } else {
                    alert("wrong");
                }
            });
        },
        async isHaveReverseItem() {
            await axios.get('api/v1/pos/checkitemreverse/' + Auth.user.id)
                .then(res => {
                    if (res.data.status == true) {
                        this.save_reverse = "Reverse"
                    }
                    if (res.data.status == false) {
                        this.save_reverse = "Save"
                    }
                })
        },
        SaveAndReverse() {
            if (this.save_reverse === 'Save') {
                axios.get('api/v1/pos/saveItem/' + Auth.user.id)
                    .then(res => {
                        this.message = res.data.message
                        this.Clearall()
                    })
            }
            if (this.save_reverse === 'Reverse') {
                axios.get('api/v1/pos/reverseItem/' + Auth.user.id)
                    .then(res => {
                        this.message = res.data.message
                    })
            }
            this.isHaveReverseItem()
            this.getdataPos()
        },
        async printDivContent(id) {
            var contentOfDiv = document.getElementById(id).outerHTML;
            var newWin = window.open('invoice', '', 'height=auto, width=400');
            await newWin.document.write('<title>Print Content of Div element by  using Javascript</title>');
            await newWin.document.write('<link rel="stylesheet" href="css/style.css">');
            await newWin.document.write('<link rel="stylesheet" href="css/pstyle.css">');
            await newWin.document.write('<link rel="stylesheet" href="css/body_invoice.css">');
            await newWin.document.write(contentOfDiv);
            newWin.document.close();
            await newWin.print();
            newWin.window.close();
            this.getdataPos();
        },
        async showValue() {
            await axios.post('api/v1/product/posSearch', this.formSearch)
                .then(res => {
                    this.products = res.data.data
                })
        }

    },
};
</script>
  